;see DemoVDD.bat

;VDD is Virtual Device Driver for MS-DOS Applications or Special Hardware
;shortly Virtual DOS Driver 

;as you see VDD is normal ring-3 DLL, which translates "commands" from MS-DOS
;application/driver/TSR, is able to pass them to Kernel Mode Driver and vice
;versa
;in addition you can help yourself by various interesting functions (NTVDM.exe):
;VDDInstallUserHook, ..IOHook, ..MemoryHook, .. and VDDSimulate16, which can
;execute routine in 16-bit code of MS-DOS application


.586P
.MODEL FLAT, STDCALL

 OPTION     CASEMAP: NONE    

 UNICODE    = 1          ; for  W32Main.inc
 INCLUDE    W32Main.inc  ; from Walk32 package by Sven B. Schreiber

 INCLUDELIB KERNEL32.lib
 INCLUDELIB NTVDM.lib 


.CODE
 DosDeviceName	     LABEL   DWORD
                     STRING  <\\.\NTfire/0>

 hDevice             DWORD INVALID_HANDLE_VALUE

 PUBLIC              DemoVDDRegister, DemoVDDDispatch

;DemoVDDRegister and DemoVDDDispatch must be EXPORTED


;-------------------------------------------------------------------------------

 EVEN
DllMain     PROC     DllHandle, Reason, pContext

    MOV     EAX,     Reason
    CMP     EAX,     DLL_PROCESS_ATTACH
    JE      Attach
    CMP     EAX,     DLL_PROCESS_DETACH   ;OR EAX, EAX
    JE      Detach
   Success:
    MOV     EAX,     TRUE       ; SUB EAX, EAX / INC EAX
    RET

 Attach:
    CMP     hDevice, INVALID_HANDLE_VALUE
    JNE     Success
    INVOKE  CreateFileW, ADDR DosDeviceName,\
                         <GENERIC_READ OR GENERIC_WRITE>,\
                         <FILE_SHARE_READ OR FILE_SHARE_WRITE>,\
                         0, OPEN_EXISTING, 0, 0
    MOV     hDevice, EAX
    CMP     EAX,     INVALID_HANDLE_VALUE
    JNE     Success

    MOV     EAX,     FALSE      ; SUB EAX, EAX
    RET

  Detach:
    INVOKE  CloseHandle, hDevice
    MOV     hDevice, INVALID_HANDLE_VALUE
    JMP     Success

DllMain     ENDP


;-------------------------------------------------------------------------------

EVEN
DemoVDDRegister PROC     ;called by RegisterModule via BOP manager
    ;init                ;you can read/set DOS registers by using get*/set* fn
    INVOKE  setCF, 0     ;success = NC
    RET
DemoVDDRegister ENDP

;-------------------------------------------------------------------------------

EVEN
DemoVDDDispatch PROC   USES EBX ESI EDI ;called by DispatchCall via BOP manager

    LOCAL   BytesReturned:DWORD
 
    INVOKE  setCF, 1     ;assume error
    INVOKE  setAX, 0     ;0 bytes written

    INVOKE  getMSW       ;"RM" or PM? segment or selector?
    AND     EAX, 1       ;isolate PE bit = FALSE/TRUE
    MOV     ESI, EAX
    INVOKE  getCX        ;my parameter CX buffer size
    MOVZX   EBX, AX
    INVOKE  getDS        
    XCHG    EDI, EAX
    SHL     EDI, 16
    INVOKE  getDX        ;my parameter DS:DX buffer
    XCHG    DI,  AX      ;EDI = DS << 16 + DX required for GetVDM functions

    INVOKE  MGetVdmPointer, EDI, EBX, ESI 
                         ;this will call Sim32pGetVDMPointer
                         ;EAX = linear address (DS:DX) 
                         ;3rd parameter: FALSE - segment addressing,
                         ;               TRUE - selector addressing

    LEA     EDX, BytesReturned
    INVOKE  DeviceIoControl, hDevice, 222003H, 0, 0, EAX, EBX, EDX,  0
                         ;222003H is IOCTL code 0 (GetVersion) for NTdump

    OR      EAX, EAX
    JZ      DeviceFailed

    INVOKE  setAX, 4     ;NTdump wrote 4 bytes directly to DOS buffer
    INVOKE  setCF, 0     ;no error

 DeviceFailed:
    RET
DemoVDDDispatch ENDP


END DllMain