;@GOTO TRANSLATE


   ;                    VDD is not Virtual Display Device
   ;contact:
   ;email: elicz@email.cz
   ;IRC  : EFnet #win32asm #dos16asm


.MODEL TINY
.586P

   RegisterModule   EQU DD 0058C4C4H      ;compare with calling VxD V86 API
   UnRegisterModule EQU DD 0158C4C4H      ;LES AX,SP vs. ARPL
   DispatchCall     EQU DD 0258C4C4H      ;what's better?

   VDDUnSimulate16  EQU DB 0C4H,0C4H,0FEH ;this bop call is needed to "indicate"
                                          ;end of 16bit code, which was called
                                          ;thru VDDSimulate16 fn

   ;there are many other bop calls C4C4, but only 58 is for 3rd party
   ;watch exception 6 handler 


.CODE
.STARTUP

   ;CS=DS=ES

   LEA   DX,   Intro
   MOV   AH,   9
   INT   21H

   MOV   AX,   3306H
   INT   21H                              ;that's needed to prevent crash

   CMP   BX,   3205H                      ;on non NT systems
   LEA   DX,   MustUnderNT
   JNE   Write

   LEA   SI,   VDDDLL                     ;DS:SI = NameZ of VDD
   LEA   DI,   VDDregister                ;ES:DI = NameZ of register routine 
                                          ;        can be 0:0 
   LEA   BX,   VDDdispatch                ;DS:BX = NameZ of Dispatch routine 
   RegisterModule                         ;returns NC , AX=handle if succeeded
   LEA   DX,   RegisterFailed
   JC    Write                            ;returns CY , AX=error code if failed

;  VDD can be loaded automaticaly with every NTVDM if you specify it in
;  HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\VirtualDeviceDrivers
;  value name VDD,  value type REG_MULTI_SZ 
;  VDD="Full path to aVDD.dll",0,"Full path to bVDD.dll",0, .. 0,0 
;  for example VDD = C:\TEMP\DemoVDD.dll

   MOV   hDLL, AX
   MOV   CX,   BufferSize                  ;my private parameter
   LEA   DX,   Buffer                      ;my private parameter
   DispatchCall                            ;required parameter: AX=handle 
   LEA   DX,   DispatchFailed
   JC    Close&Write

   OR    AX,   AX                          ;returns in AX number of written
   LEA   DX,   BufferIsEmpty               ;bytes  (private)
   JE    Close&Write

   MOV   AX,   WORD PTR Buffer             ;yes VDD could send me this WORD 
   LEA   DX,   Success                     ;in register (via set??), but buffer
   OR    MajorVersion, AH                  ;is universal
   AAM   
   XCHG  AH,   AL
   OR    MinorVersion, AX

  Close&Write:
   MOV   AX,   hDLL
   UnRegisterModule                        ;required parameter: AX=handle 

  Write:
   MOV   AH,   9
   INT   21H

  .EXIT

   Intro          DB 13,10,"*DemoVDD by EliCZ shows how (easy is) to call driver "
                  DB       "from DOS subsystem*",36

   MustUnderNT    DB 13,10,"DemoVDD must run under Windows NT!",7,36
   RegisterFailed DB 13,10,"RegisterModule failed!",7
                  DB 13,10,"Causes: NTdump isn't started. "
                  DB       "DemoVDD.dll isn't accessible.",7,36
   DispatchFailed DB 13,10,"DispatchCall failed!",7,36
   BufferIsEmpty  DB 13,10,"Buffer is empty!",7,36

   Success        DB 13,10,"NTdump version "
   MajorVersion   DB "0."
   MinorVersion   DW "00"
                  DB " is present.",36

   VDDDLL         DB "DemoVDD.dll",0
   VDDregister    DB "DemoVDDRegister",0
   VDDdispatch    DB "DemoVDDDispatch",0
   hDLL           DW ?

   EVEN
   Buffer         DD 8 DUP (?) 
   BufferSize     EQU $-Buffer
END

:TRANSLATE
@ECHO OFF
TASM  /M /Q /T %0
TLINK /3/x/t DemoVDD
DEL   DemoVDD.obj